/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef ENGINE_H
#define ENGINE_H


class AppEngine;

class AppState
{

	public:

		AppState();	
		virtual ~AppState();

		void init(AppEngine *_app);		

		// virtual functions to be overloaded
		virtual void on_init() {};
		
		virtual void on_button_down(int button) {};
		virtual void on_button_up(int button) {};
	
		virtual void think(bool first) {};

	protected:
				
		AppEngine *app;
	
};



//------------------------------------------------------------------------------------------//


class AppEngine  
{

	public:
		AppEngine(int _max_states);
		~AppEngine();
	
		bool add_state(AppState *st, int id);
		void start(int _state);
		void stop();

		void change_to_state(int _state);		
		
	protected:


		// logic
		AppState **state;
		int max_states;	

		int active_state;
		int next_state;
		
		bool quit;
		
		bool first_think;
		

};


#endif
