/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef FONT_H
#define FONT_H

#include <string>
#include <map>
#include <SDL/SDL.h>

class Font
{
	public:
	
		virtual ~Font() {};
		
		virtual int draw_text(const char *text, SDL_Surface *dest, int x, int y, bool centerH=false, bool centerV=false);
		virtual int draw_char(char character, SDL_Surface *dest, int x, int y);

		virtual int draw_unicode(const Uint16 *text, SDL_Surface *dest, int x, int y, bool centerH=false, bool centerV=false);
		virtual int draw_unicode(Uint16 unicode_char, SDL_Surface *dest, int x, int y);

		virtual int draw_utf8(const char *text, SDL_Surface *dest, int x, int y, bool centerH=false, bool centerV=false);

		virtual int get_width(const char *text);
		virtual int get_width_utf8(const char *text);
		virtual int get_width_unicode(const Uint16 *unicode_char);
		virtual int get_width_unicode(Uint16 unicode_char);
		virtual int get_height();
};

#endif
