/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef GUI_H
#define GUI_H

#include "SDL/SDL.h"
#include <vector>
#include "widget.h"
#include "bitmap.h"


class Gui
{
	public:
		Gui(int _x, int _y, int _w, int _h);
		~Gui();
				
		void add_widget(Widget *w);
		void clear();
		
		void draw(SDL_Surface *s);
		
		void on_button_down(int button);
		void on_button_up(int button);		
		
		inline int get_selected() { return selected; }
		inline int set_selected(int s) { if (s>=0 && s<widgets.size()) selected = s; }
		inline Widget *get_selected_widget() { return widgets.at(selected); }
		
	private:
		std::vector<Widget *> widgets;
		int selected;		
		int x,y,w,h;
		
};


#endif
