/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "state_chooselang.h"
#include "defines.h"
#include "bitmap.h"
#include "SDL/SDL.h"
#include "string.h"
#include "shared.h"
#include "util.h"
#include "gui.h"
#include "gui_skin.h"
#include "widget_lang.h"
#include "widget_font.h"
#include "translation.h"
#include <dirent.h>
#include <string>

// AppState //////////////////////////////////////////////////////////////////////////////////

ChooseLangState::~ChooseLangState()
{
///	if (status_text!=NULL) delete [] status_text;
}

void ChooseLangState::on_init()
{
	status_text = NULL;
	gui = new Gui(10,80,300,130);
};
		
void ChooseLangState::on_button_down(int button)
{
	gui->on_button_down(button);
	redraw();
	
	if (button==GP2X_BUTTON_X)
	{
		// cancel
		app->change_to_state(ST_PREFERENCES);
	}

	else if (button==GP2X_BUTTON_B)
	{
		shared::options->set_lang(((LangWidget *)gui->get_selected_widget())->get_name());

		std::string s = ("lang/"+shared::options->get_lang()) + ".lang";
		
		Translation::set_lang(shared::options->get_lang());

		app->change_to_state(ST_PREFERENCES);		
	}
};

void ChooseLangState::on_button_up(int button)
{
};
	
void ChooseLangState::think(bool first)
{
	if (first)
	{	
///		if (status_text!=NULL) delete []status_text;

		rescan();

		status_text = Translation::get(Translation::TXT_SELECT_CANCEL);
	
		redraw();
	}
}

void ChooseLangState::redraw()
{
	GuiSkin::get_background()->draw(shared::screen,0,0);

	gui->draw(shared::screen);
	GuiSkin::get_small_font()->draw_utf8(status_text,shared::screen,160,228,true);
		
	SDL_Flip(shared::screen);
};

void ChooseLangState::rescan()
{
	gui->clear();
	
	struct dirent *dit;
	DIR *dirp;
	
	if ((dirp=opendir("lang")) != NULL)
	{
		while ((dit = readdir(dirp)) != NULL)
		{
			if (dit->d_type!=DT_DIR)
			{
				std::string name = std::string(dit->d_name);
				name = name.substr(0,name.length()-5);

				gui->add_widget(new LangWidget(name));
			}
		}
	}
}
