/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "state_menu.h"
#include "defines.h"
#include "bitmap.h"
#include "SDL/SDL.h"
#include "shared.h"
#include "util.h"
#include "gui.h"
#include "gui_skin.h"
#include "translation.h"
#include "widget_text.h"


MenuState::~MenuState()
{
}

void MenuState::on_init()
{
	gui = new Gui(10,100,300,120);
};
		
void MenuState::on_button_down(int button)
{
	gui->on_button_down(button);
	redraw();
	
	if (button==GP2X_BUTTON_B)
	{
		switch(gui->get_selected())
		{
			case 0: // Abrir
				app->change_to_state(ST_SELECTOR);
				break;
			case 1: // Recientes
				app->change_to_state(ST_HISTORY);
				break;
			case 2: // Opciones
				app->change_to_state(ST_PREFERENCES);
				break;
			case 4: // Salir
				app->stop();
				break;
		}
	}
};

void MenuState::on_button_up(int button)
{
};
	
void MenuState::think(bool first)
{
	if (first)
	{	
		gui->clear();

		gui->add_widget(new TextWidget(Translation::get(Translation::TXT_OPEN), true,true));
		gui->add_widget(new TextWidget(Translation::get(Translation::TXT_RECENT), true,true));
		gui->add_widget(new TextWidget(Translation::get(Translation::TXT_PREFERENCES), true,true));
		gui->add_widget(new TextWidget("", false));
		gui->add_widget(new TextWidget(Translation::get(Translation::TXT_EXIT), true,true));
	
		help_text = Translation::get(Translation::TXT_SELECT);
	
		redraw();

	}
}

void MenuState::redraw()
{
	GuiSkin::get_background()->draw(shared::screen,0,0);
	gui->draw(shared::screen);
	
	GuiSkin::get_small_font()->draw_utf8(help_text,shared::screen, 160, 228, true, false);
		
	SDL_Flip(shared::screen);
};
