#include "translation.h"
#include <fstream>
#include <iostream>

#include "widget_checkbox.h"
#include "widget_font.h"

int Translation::num_lang = 0;		
bool Translation::loaded = false;
std::string Translation::strings[NUM_STRINGS];


char *Translation::get(int id)
{
	if (loaded)
	{
		return const_cast<char*> ( strings[id].c_str() );
	}
	else
	{
		return "NO LANGUAGE LOADED";
	}
}


std::string Translation::get_language_name(int id)
{
	return get(TXT_LANG);
}

void Translation::set_lang(const std::string &l)
{
	// load language file
	std::string filename = "lang/" + l;
	filename += ".lang";
	
	std::cout << filename << "\n";
	
	char temp[256];
	std::ifstream file(filename.c_str());
	for (int i=0; i<NUM_STRINGS; i++)
	{
		file.getline(temp,256);
		strings[i] = temp;
		
		
		/// special chars
		Translation::replace_special(&(strings[i]),"{A}","Ａ");		
		Translation::replace_special(&(strings[i]),"{B}","Ｂ");
		Translation::replace_special(&(strings[i]),"{X}","Ｘ");		
		Translation::replace_special(&(strings[i]),"{Y}","Ｙ");
		Translation::replace_special(&(strings[i]),"{L}","Ｌ");	
		Translation::replace_special(&(strings[i]),"{R}","Ｒ");		
		Translation::replace_special(&(strings[i]),"{s}","ｓ");		
		Translation::replace_special(&(strings[i]),"{S}","Ｓ");		
		
	}
	
	file.close();		
	
	loaded = true;

	CheckBoxWidget::refresh_lang();	
	FontWidget::refresh_lang();
	
}

void Translation::replace_special(std::string *str, const std::string& from, const std::string& to)
{
	int pos = str->find(from,0);
	if (pos!=std::string::npos)
	{
		str->replace(pos,3,to);
	}
}
