/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef TTFONT_H
#define TTFONT_H

#include <string>
#include <map>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include "font.h"

class TTFont
{
	public:
	
		TTFont();
		~TTFont();
		
		bool load(const std::string &filename, int size, SDL_Color fg, SDL_Color bg, bool antialias);

		int draw_text(const char *text, SDL_Surface *dest, int x, int y, bool centerH=false, bool centerV=false);
		int draw_char(char character, SDL_Surface *dest, int x, int y);

		int draw_unicode(const Uint16 *text, SDL_Surface *dest, int x, int y, bool centerH=false, bool centerV=false);
		int draw_unicode(Uint16 unicode_char, SDL_Surface *dest, int x, int y);

		int draw_utf8(const char *text, SDL_Surface *dest, int x, int y, bool centerH=false, bool centerV=false);

		int get_width(const char *text);
		int get_width_utf8(const char *text);
		int get_width_unicode(const Uint16 *unicode_char);
		int get_width_unicode(Uint16 unicode_char);
		int get_height();
		
		SDL_Color get_bg_color();

	
		
	private:
		SDL_Color bg_color;
		SDL_Color fg_color;
		int size;
		bool antialias;
		std::string filename;
				
		void close();
		
		TTF_Font *font;

};

#endif
