/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "util.h"

namespace util
{
	/* This function is copypasted from SDL_ttf source
	 */
	Uint16 *utf8_to_unicode_buffer(Uint16 *unicode_buffer, const char *utf8, int len)
	{
		int i, j;
		Uint16 ch;
		
		for ( i=0, j=0; i < len; ++i, ++j )
		{
			ch = ((const unsigned char *)utf8)[i];
			if ( ch >= 0xF0 )
			{
				ch  =  (Uint16)(utf8[i]&0x07) << 18;
				ch |=  (Uint16)(utf8[++i]&0x3F) << 12;
				ch |=  (Uint16)(utf8[++i]&0x3F) << 6;
				ch |=  (Uint16)(utf8[++i]&0x3F);
			}
			else if ( ch >= 0xE0 )
			{
				ch  =  (Uint16)(utf8[i]&0x0F) << 12;
				ch |=  (Uint16)(utf8[++i]&0x3F) << 6;
				ch |=  (Uint16)(utf8[++i]&0x3F);
			}
			else if ( ch >= 0xC0 )
			{
				ch  =  (Uint16)(utf8[i]&0x1F) << 6;
				ch |=  (Uint16)(utf8[++i]&0x3F);
			}
			unicode_buffer[j] = ch;
		}
		unicode_buffer[j] = 0;
		return unicode_buffer;
	}
	

	Uint16 *utf8_to_unicode(const char *utf8)
	{
		int utf8_len=strlen(utf8);
		Uint16 *unicode_buffer = new Uint16[utf8_len+2];
		*unicode_buffer = UNICODE_BOM_NATIVE;
		utf8_to_unicode_buffer(unicode_buffer, utf8, utf8_len);
		return unicode_buffer;
	}

	Uint16 *copy_unicode_substring(Uint16 *unicode_text, int begin, int end)
	{
		int length = end-begin;
		Uint16 *buffer = new Uint16[length+1];
		for (int i=0; i<length; i++)
		{
			buffer[i] = unicode_text[begin+i];
		}
		buffer[length] = 0;
		return buffer;
	}		


	Uint16 *latin1_to_unicode(const char *text, int begin, int len)
	{
		Uint16 *unicode = new Uint16[len+1];
		int i;
		for ( i=0; i < len; ++i )
		{
			unicode[i] = ((const unsigned char *)text)[i+begin];
		}
		unicode[i] = 0;
		return unicode;
	}




	void hw_set_cpu(int speed)
	{
	}


};
