/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef CHECKBOXWIDGET_H
#define CHECKBOXWIDGET_H

#include "SDL/SDL.h"
#include "widget_basic.h"
#include "bitmap.h"
#include "bitmapfont.h"
#include <vector>


class CheckBoxWidget : public BasicWidget
{
	public:

		CheckBoxWidget(Uint16 *text);
		~CheckBoxWidget();

		bool on_button_down(int button);
		bool on_button_up(int button) { return false; };
		
		
		void set_checked(bool c);
		inline bool is_checked() { return checked; }
		
		static void refresh_lang();
		
	
	private:
		bool checked;
		static Uint16 *hint_on;
		static Uint16 *hint_off;


};


#endif
