/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef SLIDERWIDGET_H
#define SLIDERWIDGET_H

#include "SDL/SDL.h"
#include "widget_basic.h"
#include "bitmap.h"
#include "bitmapfont.h"
#include <vector>


class FontWidget : public BasicWidget
{
	public:

		FontWidget(const std::string &name);
		~FontWidget();

		bool on_button_down(int button);
		bool on_button_up(int button) { return false; };
		
		void draw_custom_content(SDL_Surface *dest, int x, int y, int w, bool selected);
		int get_custom_content_height(bool selected);
		
		inline std::string get_name() { return name; }

		static void refresh_lang();			
	private:
		std::string name;

		SDL_Surface *img;
		SDL_Color font_bg;
		
		static char *preview_text;
		
};


#endif
