/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "defines.h"
#include "gui_skin.h"
#include "widget_history.h"
#include "bitmapfont.h"
#include "util.h"
#include "translation.h"
#include <vector>


HistoryWidget::HistoryWidget(const std::string &path, std::string &filename, Bitmap *icon, float percent) :  FileWidget(path, filename, false, icon)
{
	this->percent = percent;
	
	char *buffer_percent = new char[50];
	char *buffer_path = new char[50];
	
	sprintf(buffer_path,"%s: %s", Translation::get(Translation::TXT_PATH), path.c_str());
	sprintf(buffer_percent,"%s %2.2f%%",Translation::get(Translation::TXT_POSITION), percent);
	
	text_percent = util::utf8_to_unicode(buffer_percent);
	text_path = util::utf8_to_unicode(buffer_path);
	
	delete [] buffer_percent;
	delete [] buffer_path;
	
}


HistoryWidget::~HistoryWidget()
{
	delete []text_percent;
	delete []text_path;
}


void HistoryWidget::draw_custom_content(SDL_Surface *dest, int x, int y, int w, bool selected)
{
	if (selected)
	{
		GuiSkin::get_small_font()->draw_unicode(text_path, dest, x+4, y);
		GuiSkin::get_small_font()->draw_unicode(text_percent, dest, x+4, y+GuiSkin::get_small_font()->get_height());
	}
}

int HistoryWidget::get_custom_content_height(bool selected)
{
	return selected ? 2*GuiSkin::get_small_font()->get_height() : 0;
}
